# TencentCloud LogService Exporter

<!-- status autogenerated section -->
| Status        |           |
| ------------- |-----------|
| Stability     | [beta]: logs   |
| Distributions | [contrib] |

[beta]: https://github.com/open-telemetry/opentelemetry-collector#beta
[contrib]: https://github.com/open-telemetry/opentelemetry-collector-releases/tree/main/distributions/otelcol-contrib
<!-- end autogenerated section -->

This exporter supports sending OpenTelemetry log data to [LogService](https://cloud.tencent.com/product/cls).

# Configuration options:

- `region` (required): LogService's [Region](https://cloud.tencent.com/document/product/614/56473).
- `logset` (required): LogService's LogSet ID.
- `topic` (required): LogService's topic ID.
- `secret_id` (optional): TencentCloud secret id.
- `secret_key` (optional): TencentCloud secret key.

# Example:
## Simple Log Data

```yaml
receivers:
  otlp:
    protocols:
      grpc:
        endpoint: ":4317"

exporters:
  tencentcloud_logservice:
      # LogService's Region, https://cloud.tencent.com/document/product/614/18940
      # set cls.{region}.tencentcloudapi.com, eg cls.ap-beijing.tencentcloudapi.com;
    region: "ap-beijing"
    # LogService's LogSet ID
    logset: "demo-logset"
    # LogService's Topic ID
    topic: "demo-topic"
    # TencentCloud secret id
    secret_id: "demo-secret-id"
    # TencentCloud secret key
    secret_key: "demo-secret-key"

service:
  pipelines:
    logs:
      receivers: [otlp]
      exporters: [tencentcloud_logservice]
```

# Changelog

- 2021-11-10 Change configuration item **endpoint** to **region**, by @wgliang
- 2021-11-01 Initial implementation by @wgliang in #5722
