// Copyright The OpenTelemetry Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package awsxray // import "github.com/open-telemetry/opentelemetry-collector-contrib/internal/aws/xray"

// String returns a pointer to the provided string, or nil if it is an empty string.
func String(v string) *string {
	if v == "" {
		return nil
	}
	return &v
}

// StringOrEmpty returns empty string if the input is nil, otherwise returns the string itself.
func StringOrEmpty(v *string) string {
	if v == nil {
		return ""
	}
	return *v
}
