// Code generated by mdatagen. DO NOT EDIT.

package metadata

import "go.opentelemetry.io/collector/confmap"

// MetricConfig provides common config for a particular metric.
type MetricConfig struct {
	Enabled bool `mapstructure:"enabled"`

	enabledSetByUser bool
}

func (ms *MetricConfig) Unmarshal(parser *confmap.Conf) error {
	if parser == nil {
		return nil
	}
	err := parser.Unmarshal(ms, confmap.WithErrorUnused())
	if err != nil {
		return err
	}
	ms.enabledSetByUser = parser.IsSet("enabled")
	return nil
}

// MetricsConfig provides config for haproxyreceiver metrics.
type MetricsConfig struct {
	HaproxyBytesInput           MetricConfig `mapstructure:"haproxy.bytes.input"`
	HaproxyBytesOutput          MetricConfig `mapstructure:"haproxy.bytes.output"`
	HaproxyClientsCanceled      MetricConfig `mapstructure:"haproxy.clients.canceled"`
	HaproxyCompressionBypass    MetricConfig `mapstructure:"haproxy.compression.bypass"`
	HaproxyCompressionCount     MetricConfig `mapstructure:"haproxy.compression.count"`
	HaproxyCompressionInput     MetricConfig `mapstructure:"haproxy.compression.input"`
	HaproxyCompressionOutput    MetricConfig `mapstructure:"haproxy.compression.output"`
	HaproxyConnectionsErrors    MetricConfig `mapstructure:"haproxy.connections.errors"`
	HaproxyConnectionsRate      MetricConfig `mapstructure:"haproxy.connections.rate"`
	HaproxyConnectionsRetries   MetricConfig `mapstructure:"haproxy.connections.retries"`
	HaproxyConnectionsTotal     MetricConfig `mapstructure:"haproxy.connections.total"`
	HaproxyDowntime             MetricConfig `mapstructure:"haproxy.downtime"`
	HaproxyFailedChecks         MetricConfig `mapstructure:"haproxy.failed_checks"`
	HaproxyRequestsDenied       MetricConfig `mapstructure:"haproxy.requests.denied"`
	HaproxyRequestsErrors       MetricConfig `mapstructure:"haproxy.requests.errors"`
	HaproxyRequestsQueued       MetricConfig `mapstructure:"haproxy.requests.queued"`
	HaproxyRequestsRate         MetricConfig `mapstructure:"haproxy.requests.rate"`
	HaproxyRequestsRedispatched MetricConfig `mapstructure:"haproxy.requests.redispatched"`
	HaproxyRequestsTotal        MetricConfig `mapstructure:"haproxy.requests.total"`
	HaproxyResponsesDenied      MetricConfig `mapstructure:"haproxy.responses.denied"`
	HaproxyResponsesErrors      MetricConfig `mapstructure:"haproxy.responses.errors"`
	HaproxyServerSelectedTotal  MetricConfig `mapstructure:"haproxy.server_selected.total"`
	HaproxySessionsAverage      MetricConfig `mapstructure:"haproxy.sessions.average"`
	HaproxySessionsCount        MetricConfig `mapstructure:"haproxy.sessions.count"`
	HaproxySessionsRate         MetricConfig `mapstructure:"haproxy.sessions.rate"`
	HaproxySessionsTotal        MetricConfig `mapstructure:"haproxy.sessions.total"`
}

func DefaultMetricsConfig() MetricsConfig {
	return MetricsConfig{
		HaproxyBytesInput: MetricConfig{
			Enabled: true,
		},
		HaproxyBytesOutput: MetricConfig{
			Enabled: true,
		},
		HaproxyClientsCanceled: MetricConfig{
			Enabled: false,
		},
		HaproxyCompressionBypass: MetricConfig{
			Enabled: false,
		},
		HaproxyCompressionCount: MetricConfig{
			Enabled: false,
		},
		HaproxyCompressionInput: MetricConfig{
			Enabled: false,
		},
		HaproxyCompressionOutput: MetricConfig{
			Enabled: false,
		},
		HaproxyConnectionsErrors: MetricConfig{
			Enabled: true,
		},
		HaproxyConnectionsRate: MetricConfig{
			Enabled: true,
		},
		HaproxyConnectionsRetries: MetricConfig{
			Enabled: true,
		},
		HaproxyConnectionsTotal: MetricConfig{
			Enabled: false,
		},
		HaproxyDowntime: MetricConfig{
			Enabled: false,
		},
		HaproxyFailedChecks: MetricConfig{
			Enabled: false,
		},
		HaproxyRequestsDenied: MetricConfig{
			Enabled: true,
		},
		HaproxyRequestsErrors: MetricConfig{
			Enabled: true,
		},
		HaproxyRequestsQueued: MetricConfig{
			Enabled: true,
		},
		HaproxyRequestsRate: MetricConfig{
			Enabled: true,
		},
		HaproxyRequestsRedispatched: MetricConfig{
			Enabled: true,
		},
		HaproxyRequestsTotal: MetricConfig{
			Enabled: true,
		},
		HaproxyResponsesDenied: MetricConfig{
			Enabled: true,
		},
		HaproxyResponsesErrors: MetricConfig{
			Enabled: true,
		},
		HaproxyServerSelectedTotal: MetricConfig{
			Enabled: true,
		},
		HaproxySessionsAverage: MetricConfig{
			Enabled: true,
		},
		HaproxySessionsCount: MetricConfig{
			Enabled: true,
		},
		HaproxySessionsRate: MetricConfig{
			Enabled: true,
		},
		HaproxySessionsTotal: MetricConfig{
			Enabled: false,
		},
	}
}

// ResourceAttributeConfig provides common config for a particular resource attribute.
type ResourceAttributeConfig struct {
	Enabled bool `mapstructure:"enabled"`
}

// ResourceAttributesConfig provides config for haproxyreceiver resource attributes.
type ResourceAttributesConfig struct {
	HaproxyAddr ResourceAttributeConfig `mapstructure:"haproxy.addr"`
	HaproxyAlgo ResourceAttributeConfig `mapstructure:"haproxy.algo"`
	HaproxyIid  ResourceAttributeConfig `mapstructure:"haproxy.iid"`
	HaproxyPid  ResourceAttributeConfig `mapstructure:"haproxy.pid"`
	HaproxySid  ResourceAttributeConfig `mapstructure:"haproxy.sid"`
	HaproxyType ResourceAttributeConfig `mapstructure:"haproxy.type"`
	HaproxyURL  ResourceAttributeConfig `mapstructure:"haproxy.url"`
	ProxyName   ResourceAttributeConfig `mapstructure:"proxy_name"`
	ServiceName ResourceAttributeConfig `mapstructure:"service_name"`
}

func DefaultResourceAttributesConfig() ResourceAttributesConfig {
	return ResourceAttributesConfig{
		HaproxyAddr: ResourceAttributeConfig{
			Enabled: true,
		},
		HaproxyAlgo: ResourceAttributeConfig{
			Enabled: true,
		},
		HaproxyIid: ResourceAttributeConfig{
			Enabled: true,
		},
		HaproxyPid: ResourceAttributeConfig{
			Enabled: true,
		},
		HaproxySid: ResourceAttributeConfig{
			Enabled: true,
		},
		HaproxyType: ResourceAttributeConfig{
			Enabled: true,
		},
		HaproxyURL: ResourceAttributeConfig{
			Enabled: true,
		},
		ProxyName: ResourceAttributeConfig{
			Enabled: false,
		},
		ServiceName: ResourceAttributeConfig{
			Enabled: false,
		},
	}
}

// MetricsBuilderConfig is a configuration for haproxyreceiver metrics builder.
type MetricsBuilderConfig struct {
	Metrics            MetricsConfig            `mapstructure:"metrics"`
	ResourceAttributes ResourceAttributesConfig `mapstructure:"resource_attributes"`
}

func DefaultMetricsBuilderConfig() MetricsBuilderConfig {
	return MetricsBuilderConfig{
		Metrics:            DefaultMetricsConfig(),
		ResourceAttributes: DefaultResourceAttributesConfig(),
	}
}
