// Code generated by mdatagen. DO NOT EDIT.

package metadata

import "go.opentelemetry.io/collector/confmap"

// MetricConfig provides common config for a particular metric.
type MetricConfig struct {
	Enabled bool `mapstructure:"enabled"`

	enabledSetByUser bool
}

func (ms *MetricConfig) Unmarshal(parser *confmap.Conf) error {
	if parser == nil {
		return nil
	}
	err := parser.Unmarshal(ms, confmap.WithErrorUnused())
	if err != nil {
		return err
	}
	ms.enabledSetByUser = parser.IsSet("enabled")
	return nil
}

// MetricsConfig provides config for riakreceiver metrics.
type MetricsConfig struct {
	RiakMemoryLimit              MetricConfig `mapstructure:"riak.memory.limit"`
	RiakNodeOperationCount       MetricConfig `mapstructure:"riak.node.operation.count"`
	RiakNodeOperationTimeMean    MetricConfig `mapstructure:"riak.node.operation.time.mean"`
	RiakNodeReadRepairCount      MetricConfig `mapstructure:"riak.node.read_repair.count"`
	RiakVnodeIndexOperationCount MetricConfig `mapstructure:"riak.vnode.index.operation.count"`
	RiakVnodeOperationCount      MetricConfig `mapstructure:"riak.vnode.operation.count"`
}

func DefaultMetricsConfig() MetricsConfig {
	return MetricsConfig{
		RiakMemoryLimit: MetricConfig{
			Enabled: true,
		},
		RiakNodeOperationCount: MetricConfig{
			Enabled: true,
		},
		RiakNodeOperationTimeMean: MetricConfig{
			Enabled: true,
		},
		RiakNodeReadRepairCount: MetricConfig{
			Enabled: true,
		},
		RiakVnodeIndexOperationCount: MetricConfig{
			Enabled: true,
		},
		RiakVnodeOperationCount: MetricConfig{
			Enabled: true,
		},
	}
}

// ResourceAttributeConfig provides common config for a particular resource attribute.
type ResourceAttributeConfig struct {
	Enabled bool `mapstructure:"enabled"`
}

// ResourceAttributesConfig provides config for riakreceiver resource attributes.
type ResourceAttributesConfig struct {
	RiakNodeName ResourceAttributeConfig `mapstructure:"riak.node.name"`
}

func DefaultResourceAttributesConfig() ResourceAttributesConfig {
	return ResourceAttributesConfig{
		RiakNodeName: ResourceAttributeConfig{
			Enabled: true,
		},
	}
}

// MetricsBuilderConfig is a configuration for riakreceiver metrics builder.
type MetricsBuilderConfig struct {
	Metrics            MetricsConfig            `mapstructure:"metrics"`
	ResourceAttributes ResourceAttributesConfig `mapstructure:"resource_attributes"`
}

func DefaultMetricsBuilderConfig() MetricsBuilderConfig {
	return MetricsBuilderConfig{
		Metrics:            DefaultMetricsConfig(),
		ResourceAttributes: DefaultResourceAttributesConfig(),
	}
}
